package rione.agent;

import java.util.*;

import rescuecore2.standard.entities.Area;
import rescuecore2.worldmodel.EntityID;
import rione.object.*;

public class Router {

	/**
	 * A*探索
	 * @param origin
	 * @param destinations
	 * @param costFunc
	 * @param model
	 * @return
	 */
	public static List<EntityID> get(Area origin, Area destination, CostFunction costFunc , AdvancedWorldModel model) {
		PriorityQueue<Route> open = new PriorityQueue<Route>();
		Set<Route> close = new HashSet<Route>();
		
		// Set<Street> visited = new HashSet<Street>();
		Street location = model.getOwnStreet(origin.getID());
		
		// オープンリストに追加
		open.offer(new Route(location, location.getHead(), location.divideRoute(origin, location.getHead()), location.getHeadSideNeignbhorStreets()));
		open.offer(new Route(location, location.getTail(), location.divideRoute(origin, location.getTail()), location.getTailSideNeignbhorStreets()));

					
		while (!open.isEmpty()) {
			Route route = open.poll(); // 要素を取り出して削除
			if ( route.current.contains(destination)) { // 目標地点に到達
				return route.getRoute(destination);
			}
			close.add(route);
			//visited.add(route.end); // 後戻り対策
			for (Street street : route.getNexts()) { 
				update(open, route.expandedRoute(street, route.end, costFunc, destination));
			}
		}
		return null;
	}
	
	private static void update(PriorityQueue<Route> open, Route route) {
		for (Iterator<Route> it = open.iterator(); it.hasNext();) {
			Route rt = it.next();
			// 同じ目標地点により小さなコストでいけるのであれば置き換え
			if (rt.end.equals(route.end)) {
				if (rt.cost() > route.cost()) {
					it.remove();
					//open.offer(route);
				}
				break;
			}
		}
		open.offer(route);
	}
}
