package rione.agent.at;

import java.util.EnumSet;

import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.standard.messages.StandardMessageURN;
import rescuecore2.worldmodel.EntityID;
import rione.agent.PlatoonAgent;

public abstract class AbstractAmbulanceTeamAgent extends
		PlatoonAgent<AmbulanceTeam> {

	protected void rescue(EntityID target) throws ActionCommandException {
		sendRescue(time, target);
		throw new ActionCommandException(StandardMessageURN.AK_RESCUE);
	}

	protected void rescue(Human target) throws ActionCommandException {
		rescue(target.getID());
	}

	protected void load(EntityID target) throws ActionCommandException {
		sendLoad(time, target);
		throw new ActionCommandException(StandardMessageURN.AK_LOAD);
	}

	protected void load(Human target) throws ActionCommandException {
		load(target.getID());
	}

	protected void unload() throws ActionCommandException {
		sendUnload(time);
		throw new ActionCommandException(StandardMessageURN.AK_UNLOAD);
	}

	@Override
	protected void initialize() {
		super.initialize();
	}

	@Override
	protected EnumSet<StandardEntityURN> getRequestedEntityURNsEnum() {
		return EnumSet.of(StandardEntityURN.AMBULANCE_TEAM);
	}
}
