package rione.communication;

/**
 * 通信用データを表現するクラス．
 * @author Suzuki->utisam
 */
abstract public class MessageData implements Comparable<MessageData> {

	/** 通信優先度． */
	protected int priority;

	/** 優先度のデフォルト値． */
	protected static final int DEFAULT_PRIORITY = 0;

	public int getPriority() {
		return priority;
	}

	public void setPriotiry(int priority) {
		this.priority = priority;
	}

	@Override
	public int compareTo(MessageData o) {
		//値が高い方が優先される
		return o.priority - getPriority();
	}
}