package rione.communication;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardEntityConstants.Fieryness;
import rione.object.AdvancedWorldModel;

public class VoiceMessageMaker extends AbstractMessageMaker {

	public VoiceMessageMaker(AdvancedWorldModel world) {
		super(world);
	}

	@Override
	public MessageData make(StandardEntity entity) {
		StanderdEntityMessageData data = new StanderdEntityMessageData();
		// int priority = 0;

		data.setEntity(entity);
		// --------------------
		// 優先度評価関数作る;
		// 通信のpriorityのdefaltの値は0
		// --------------------
		switch (entity.getStandardURN()) {
		case ROAD:
			data.setPriotiry(50);
			break;
		// case BLOCKADE :
		// break;
		case BUILDING:
			data.setPriotiry(100);
			if (((Building) entity).getFierynessEnum() == Fieryness.UNBURNT) {
				if (((Building) entity).isBrokennessDefined() && ((Building) entity).getBrokenness() > 10) {
					data.setPriotiry(90);
				}
				else {
					data.setPriotiry(Integer.MIN_VALUE);
				}
			}
			break;
		case CIVILIAN:
			if (((Human) entity).getHP() <= 100) {
				data.setPriotiry(-1);
			}
			else {
				data.setPriotiry(10);
			}
			break;
		case FIRE_BRIGADE:
			if (world.me() != null && entity.getID().getValue() == world.me().getID().getValue()) {
				data.setPriotiry(45);
				break;
			}
			data.setPriotiry(20);
			break;
		case POLICE_FORCE:
			data.setPriotiry(15);
			break;
		case AMBULANCE_TEAM:
			data.setPriotiry(7);
			break;
		// case REFUGE :
		// break;
		default:
			data.setPriotiry(1);
		}
		return data;
	}

}
